def directories = ["e:\\code\\adapters", "e:\\code\\automator"]
def exclusions = ["com\\chrisdail\\excluded", "src\\test"] as Set
def inclusions = ["com\\chrisdail", "com\\another"] as Set

directories.each {root->
    def lineCount = 0
    def significantCount = 0
    
    new File(root).eachDirRecurse {dir ->
        // If no inclusion is present, return
        if (!inclusions.any {dir.absolutePath.contains(it)}) {
            return
        }
        
        // If any exclusion is present, return
        if (exclusions.any {dir.absolutePath.contains(it)}) {
            return
        }
        
        dir.eachFileMatch(~/.*\.(groovy|java|g|xml|properties)/) {file ->
            file.eachLine {
                def line = it.trim()
                if (line != "") {
                    lineCount++
                    if (line.size() > 2 && !line.startsWith("//") && !line.startsWith("/*")
                            && !line.startsWith("*") && !line.startsWith("import")) {
                        significantCount++
                    }
                }
            }
        }
    }
    
    println "Lines in '$root': $significantCount / $lineCount"
}
